// Ovaj program treba da dopopuni trapentry.S u kojem je vec pripremljen _alltrap rutina
// Takodjer ovaj program ce izvrsiti promjenu trapentry.S samo ako ako pri pokretanju na pocetku fajla se nalazi posebni magic string inace nece nista uraditi

#include<fstream>
#include<iostream>
#include<string>
#include<vector>

int main(){
  std::ifstream input("kern/trapentry.S");
  if ( ! input.is_open() ){
    std::cout << "File can not be open or maybe does not exist!\n";
    return -1;
  }

  std::string line;
  std::getline( input , line );
  if( line != "#MIRSAD_01122017-D" ){
    std::cout << "File has already been changed, magic string is missing\n";
    std::cout << line << std::endl;
    return -2;
  }

  std::vector<std::string> new_trapentry;
  while( getline(input,line) )
    new_trapentry.push_back(line);

  new_trapentry.push_back( "\n\n\n#This section was generated by program defined in set_trapentry.cpp\n#Must not be edit\n\n" );
  new_trapentry.push_back("  .text");
  for( std::size_t i = 0u ; i < 256 ; ++i ){
    if( i == 8u || ( i >= 10u && i <= 14u  ) || i == 17u || i == 30u )
      new_trapentry.push_back( "    TRAPHANDLER( vector" + std::to_string(i) + " , " + std::to_string(i) + " )" );
    else
      new_trapentry.push_back( "    TRAPHANDLER_NOEC( vector" + std::to_string(i) + " , " + std::to_string(i) + " )" );
  }

  new_trapentry.push_back("\n\n\n");
  new_trapentry.push_back("  .data");
  new_trapentry.push_back("    .globl vectors");
  new_trapentry.push_back("    vectors:");
  for( std::size_t i = 0u ; i < 256 ; ++i )
    new_trapentry.push_back( std::string("      .long vector") + std::to_string(i) );
 

  input.close();
  
  std::fstream out("kern/trapentry.S");
  if( ! out.is_open() ){
    std::cout << "File can not be open\n";
    return -3;
  }

  for( const auto & elem : new_trapentry )
    out << elem << std::endl;

  return 0;

}

